/* Sistemas Integrados TEKNISA
   Compras e Suprimentos

Nome: 8145_SUPFUNO.sql

Descrio:
- retorna valores para a separao de AF's por impostos

Criao:
23/03/2006 - Marcelo Alexsandro Souza Silva
*/

CREATE OR REPLACE FUNCTION SEPARA_AF_IMPOSTO_FUN
(P_CDFILDEST    IN IMPITMAF.CDFILDEST%TYPE,
 P_CDFILLANC    IN IMPITMAF.CDFILLANC%TYPE,
 P_NRAUTOFORN   IN IMPITMAF.NRAUTOFORN%TYPE,
 P_CDPRODUTO    IN IMPITMAF.CDPRODUTO%TYPE,
 P_CDMARCA      IN IMPITMAF.CDMARCA%TYPE,
 P_DTPROGENTAF  IN IMPITMAF.DTPROGENTAF%TYPE
)  RETURN VARCHAR2
IS
   V_CTIMPOSTO NUMBER;
   V_RETURN VARCHAR2(2);
BEGIN
   SELECT
      COUNT(*)
   INTO
      V_CTIMPOSTO
   FROM
      IMPITMAF
   WHERE
      IMPITMAF.CDFILDEST   = P_CDFILDEST    AND
      IMPITMAF.CDFILLANC   = P_CDFILLANC    AND
      IMPITMAF.NRAUTOFORN  = P_NRAUTOFORN   AND
      IMPITMAF.CDPRODUTO   = P_CDPRODUTO    AND
      IMPITMAF.CDMARCA     = P_CDMARCA      AND
      IMPITMAF.DTPROGENTAF = P_DTPROGENTAF;
   IF V_CTIMPOSTO = 0 THEN
      V_RETURN := 'Z';
   ELSE
      IF V_CTIMPOSTO = 1 THEN
         SELECT DISTINCT
            CDIMPOSTO
         INTO
            V_RETURN
         FROM
            IMPITMAF
         WHERE
            IMPITMAF.CDFILDEST   = P_CDFILDEST    AND
            IMPITMAF.CDFILLANC   = P_CDFILLANC    AND
            IMPITMAF.NRAUTOFORN  = P_NRAUTOFORN   AND
            IMPITMAF.CDPRODUTO   = P_CDPRODUTO    AND
            IMPITMAF.CDMARCA     = P_CDMARCA      AND
            IMPITMAF.DTPROGENTAF = P_DTPROGENTAF;
      ELSE
         IF V_CTIMPOSTO > 1 THEN
            V_RETURN := 'W';
         END IF;
      END IF;
   END IF;
   RETURN(V_RETURN);
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('SEPARA_AF_IMPOSTO_FUN','4.07.027'); END;
/

