function Dfe16000_ConsistenciasAfNf_Controller(ScreenService, Dfe16000_ConsistenciasAfNf_Service) {

	var changeDateFieldValues = function(currentRow) {
		currentRow.P_DTINICIAL = !currentRow.DTINTERVALO ? null : currentRow.DTINTERVALO.start;
		currentRow.P_DTFINAL = !currentRow.DTINTERVALO ? null : currentRow.DTINTERVALO.end;
	};

	var concatNotasList = function(currentRow) {
		if (Array.isArray(currentRow.CHAVE) && currentRow.CHAVE.length > 0) {
			currentRow.L_CHAVE = '_' + currentRow.CHAVE.join('_') + '_';
		}
		else {
			currentRow.L_CHAVE = null;
		}
	};

	var concatUnidadeList = function(currentRow) {
		if (currentRow.T_CDFILIAL == "L" && Array.isArray(currentRow.CDFILIAL) && currentRow.CDFILIAL.length > 0) {
			currentRow.L_CDFILIRECE = '_' + currentRow.CDFILIAL.join('_') + '_';
		}
		else {
			currentRow.L_CDFILIRECE = null;
		}
	};

	this.loadNotasField = function(widget) {
		var listaNotasField = widget.getField("CHAVE");
		var currentRow = widget.currentRow;
		changeDateFieldValues(currentRow);
		Dfe16000_ConsistenciasAfNf_Service.getMainQueryData(widget.currentRow).then(function(data) {
			listaNotasField.dataSource.data = data.dataset.mainQueryData;
		});
	};

	var openReport = function(widget) {
		widget.currentRow.__report_name = widget.currentRow.NMRELATORIO;
		Dfe16000_ConsistenciasAfNf_Service.generateReport(widget.currentRow).then(function(response) {
			if (response && response.messages) {
				var report = response.messages.pop();
				window.open(report.message);
			}
		}, function(error) {
			var errorMessage = 'Timeout';
			if (error.data) {
				errorMessage = ScreenService.i18n(error.data.error);
			}
			ScreenService.showMessage(errorMessage, 'E');
		});
	};

	this.setDefaultData = function(widget) {
		widget.currentRow.T_CDFILIAL = "T";
		widget.currentRow.NMRELATORIO = "DFE16000";
	};

	this.toggleReadOnlyNotasOnChange = function(widget) {
		var listaNotasField = widget.getField("CHAVE");
		var currentRow = widget.currentRow;
		concatUnidadeList(currentRow);
		changeDateFieldValues(currentRow);
		if ((currentRow.CDFILIAL) && (currentRow.DTINTERVALO)) {
			listaNotasField.readOnly = false;
		}
		else {
			listaNotasField.readOnly = true;
		}
		listaNotasField.setValue(null);
	};

	this.toggleReadOnlyUnidadesOnChange = function(widget) {
		var listaFilialField = widget.getField("CDFILIAL");
		if (widget.currentRow.T_CDFILIAL == "T") {
			listaFilialField.readOnly = true;
			listaFilialField.validations = {};
		}
		else {
			listaFilialField.readOnly = false;
			listaFilialField.validations = {required: true};
		}
		widget.currentRow.CDFILIAL = [];
	};

	this.validateReport = function(widget) {
		if (widget.isValid()) {
			concatUnidadeList(widget.currentRow);
			concatNotasList(widget.currentRow);
			changeDateFieldValues(widget.currentRow);
			Dfe16000_ConsistenciasAfNf_Service.checkDataExistance(widget.currentRow).then(function(thereIsData) {
				if (thereIsData) {
					openReport(widget);
				}
				else {
					ScreenService.showMessage(ScreenService.i18n("Não há dados a serem listados"));
				}
			}, function(error) {
				var errorMessage = 'Timeout';
				if (error.data) {
					errorMessage = ScreenService.i18n(error.data.error);
				}
				ScreenService.showMessage(errorMessage, 'E');
			});
		}
	};
}

Configuration(function(ContextRegister) {
	ContextRegister.register('Dfe16000_ConsistenciasAfNf_Controller', Dfe16000_ConsistenciasAfNf_Controller);
});
